package com.pomelotea.api

import okhttp3.FormBody
import okhttp3.Headers
import okhttp3.OkHttpClient
import okhttp3.Request
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestParam
import org.springframework.web.bind.annotation.RestController
import java.time.Duration
import javax.servlet.http.HttpServletRequest

/**
 *
 * @version 0.0.1
 * @author jimlee
 * date 2022-11-02 10:29
 *
 **/
@RestController
class HealthCodeController {

    val json = """
        {
        	"success": true,
        	"errorCode": null,
        	"errorMsg": null,
        	"result": "{\"reason\":\"0\",\"zlbLogoSize\":30,\"vaccinated\":\"3\",\"modifiedTimes\":0,\"logoUrl\":\"//img.alicdn.com/imgextra/i1/O1CN01RTcWEm1mriBsqhQ3Q_!!6000000005008-2-tps-516-516.png\",\"uid\":2945226479,\"descEn\":\"Green Code: It gives you greenlight at public venues and major checkpoints in Zhejiang;Be attentive to your health condition;the code color might change when your health status or local regulations change.\",\"descCn\":\"绿码：凭此码可在浙江省范围内通行，请主动出示，配合检查；并做好自身防护工作，码颜色将根据您的申报由当地政府按照相关政策动态更新，出行前请仔细检查您的健康。\",\"logoSize\":30,\"vaccinatedSwitch\":true,\"name\":\"李建明\",\"healthRecord\":{\"colorCss\":\"#27AE64\",\"qrCode\":\"V0dinga7e710d462f82d242e2feadba6d9041e\",\"feControlModel\":{\"tips\":\"\",\"enTips\":\"\"},\"stateCouncilBarCode\":\"d8cbdc8eb52a2fcc9bc6864bccd8f917\",\"eHealthCode\":\"\",\"qrColor\":\"green\",\"extInfo\":\"{\\\"nucleicData\\\":{\\\"nucleicDescriptionEn\\\":\\\"d\\\",\\\"nucleicDescriptionCn\\\":\\\"天内\\\",\\\"countDownDescriptionEn\\\":\\\"3 Days To Maturity\\\",\\\"nucleicStatusCn\\\":\\\"阴性\\\",\\\"countDownDescriptionCn\\\":\\\"距离3天到期还剩\\\",\\\"nucleicStatusEn\\\":\\\"Neg\\\",\\\"expireSpecVal\\\":\\\"168\\\",\\\"showCompareTime\\\":true,\\\"lessthenDayNumbersDisplayAsHours\\\":2,\\\"compareType\\\":\\\"report\\\",\\\"checkTime\\\":\\\"2022-10-30 10:48:06\\\",\\\"hourValue\\\":67.0,\\\"nucleicDayEn\\\":\\\"≤3\\\",\\\"timeInterval\\\":\\\"72\\\",\\\"nucleicDayCn\\\":3,\\\"countDown\\\":17608,\\\"compareTime\\\":\\\"2022-10-30 15:21:44\\\",\\\"reportTime\\\":\\\"2022-10-30 15:21:44\\\",\\\"recentNoNucleicDay\\\":3}}\"},\"descCss\":\"#333333\",\"config\":\"{\\\"travelCardUrl\\\":\\\"alipays://platformapi/startapp?appId=2019011763060066&page=pages%2Fjourney-webview%2Fjourney-webview\\\",\\\"travelCardUrlH5\\\":\\\"https://xc.caict.ac.cn/?code=152&phone={phone}&t={timestamp}&ad=1\\\"}\"}",
        	"arguments": null
        }
    """.trimIndent()



    @PostMapping("/unAuthLwp/queryHealthInfoByAuthCode")
    fun queryHealthInfoByAuthCode(@RequestParam args: String, request: HttpServletRequest): String? {
        val client = OkHttpClient()
            .newBuilder()
            .connectTimeout(Duration.ofSeconds(10))
            .callTimeout(Duration.ofSeconds(10))
            .build()

        val headerList: MutableList<String> = ArrayList()
        val reqHeaders = request.headerNames
        for (header in reqHeaders) {
            headerList.add(header)
            headerList.add(request.getHeader(header))
        }
        headerList.add("Cookie")
        headerList.add(request.cookies.toString())
        val headers: Headers = Headers.headersOf(*headerList.toTypedArray())

        val request = Request.Builder()
            .url("https://healthcode.dingtalk.com/unAuthLwp/queryHealthInfoByAuthCode")
            .post(
                FormBody.Builder().add("args", args).build()
            )
            .headers(headers)
            .build()

        val response = client.newCall(request).execute()
        val bodyString: String? = response.body?.string()
        println(bodyString)
        return json
    }
}