package com.pomelotea.api

import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PutMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestParam
import org.springframework.web.bind.annotation.RestController

/**
 *
 * @version 0.0.1
 * @author jimlee
 * date 2022-08-04 12:53
 *
 **/
@RestController
class TempClipboardController {

    @GetMapping("/clipboard")
    fun getValue(): String {
        return clipData
    }

    @PutMapping("/clipboard")
    fun putValue(@RequestBody putDataRequest: PutDataRequest): String {
        if (putDataRequest.value != null) {
            clipData = putDataRequest.value
        }
        return "success"
    }


    /**
    "1":  "青草",
    "2":  "萝卜",
    "3":  "玉米",
    "4":  "树桩",
    "5":  "草叉",
    "6":  "白菜",
    "7":  "羊毛",
    "8":  "刷子",
    "9":  "剪刀",
    "10": "奶瓶",
    "11": "水桶",
    "12": "手套",
    "13": "铃铛",
    "14": "火堆",
    "15": "毛球",
    "16": "干草"
     */

    @GetMapping("/sheep/v1/game/map_info")
    fun mapInfo(@RequestParam map_id: Int): String {
        if (map_id == 80001) {
            return "{\"err_code\":0,\"err_msg\":\"\",\"data\":{\"id\":\"62ccde7d3dd1931da84a84e2\",\"created_at\":\"2022-07-12T02:37:49.515Z\",\"updated_at\":\"2022-09-16T15:34:38.466Z\",\"map_option\":0,\"map_id\":80001,\"map_md5\":\"046ef1bab26e5b9bfe2473ded237b572\",\"map_data\":\"{\\\"levelKey\\\":80001,\\\"levelData\\\":{\\\"1\\\":[{\\\"id\\\":\\\"1-16-16\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":16,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-28-16\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":16,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-40-16\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":16,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-16-32\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":32,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-28-32\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":32,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-40-32\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":32,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-16-48\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":48,\\\"layerNum\\\":1,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-28-48\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":48,\\\"layerNum\\\":1,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-40-48\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":48,\\\"layerNum\\\":1,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"2\\\":[{\\\"id\\\":\\\"2-16-36\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":36,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-28-36\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":36,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-40-36\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":36,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-16-20\\\",\\\"type\\\":1,\\\"rolNum\\\":16,\\\"rowNum\\\":20,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-28-20\\\",\\\"type\\\":1,\\\"rolNum\\\":28,\\\"rowNum\\\":20,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-40-20\\\",\\\"type\\\":1,\\\"rolNum\\\":40,\\\"rowNum\\\":20,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-16-49\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":49,\\\"layerNum\\\":2,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-28-49\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":49,\\\"layerNum\\\":2,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-40-49\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":49,\\\"layerNum\\\":2,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"3\\\":[]},\\\"blockTypeData\\\":{\\\"1\\\":1,\\\"2\\\":2,\\\"3\\\":2},\\\"heightNum\\\":10,\\\"widthNum\\\":8}\"}}"
        } else if (map_id == 90017) {
            return "{\"err_code\":0,\"err_msg\":\"\",\"data\":{\"id\":\"62ce3ffb3dd1931da84a84f2\",\"created_at\":\"2022-07-13T03:46:03.137Z\",\"updated_at\":\"2022-09-16T15:37:48.57Z\",\"map_option\":0,\"map_id\":90017,\"map_md5\":\"0ab7e20517846172bb9a337688aaad1d\",\"map_data\":\"{\\\"widthNum\\\":8,\\\"heightNum\\\":10,\\\"levelKey\\\":90017,\\\"" +
                    "blockTypeData\\\":{\\\"1\\\":32,\\\"2\\\":32,\\\"3\\\":32}," +
                    "\\\"levelData\\\":{\\\"1\\\":[{\\\"id\\\":\\\"1-24-16\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":16,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-32-16\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":16,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-24-24\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":24,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-32-24\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":24,\\\"layerNum\\\":1,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-4-56\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":56,\\\"layerNum\\\":1,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"1-52-56\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":56,\\\"layerNum\\\":1,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"2\\\":[{\\\"id\\\":\\\"2-20-20\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":20,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-28-20\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":20,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-36-20\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":20,\\\"layerNum\\\":2,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-5-56\\\",\\\"type\\\":0,\\\"rolNum\\\":5,\\\"rowNum\\\":56,\\\"layerNum\\\":2,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"2-51-56\\\",\\\"type\\\":0,\\\"rolNum\\\":51,\\\"rowNum\\\":56,\\\"layerNum\\\":2,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"3\\\":[{\\\"id\\\":\\\"3-24-16\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":16,\\\"layerNum\\\":3,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"3-32-16\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":16,\\\"layerNum\\\":3,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"3-24-24\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":24,\\\"layerNum\\\":3,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"3-32-24\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":24,\\\"layerNum\\\":3,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"3-6-56\\\",\\\"type\\\":0,\\\"rolNum\\\":6,\\\"rowNum\\\":56,\\\"layerNum\\\":3,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"3-50-56\\\",\\\"type\\\":0,\\\"rolNum\\\":50,\\\"rowNum\\\":56,\\\"layerNum\\\":3,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"4\\\":[{\\\"id\\\":\\\"4-20-20\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":20,\\\"layerNum\\\":4,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"4-28-20\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":20,\\\"layerNum\\\":4,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"4-36-20\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":20,\\\"layerNum\\\":4,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"4-7-56\\\",\\\"type\\\":0,\\\"rolNum\\\":7,\\\"rowNum\\\":56,\\\"layerNum\\\":4,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"4-49-56\\\",\\\"type\\\":0,\\\"rolNum\\\":49,\\\"rowNum\\\":56,\\\"layerNum\\\":4,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"5\\\":[{\\\"id\\\":\\\"5-24-16\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":16,\\\"layerNum\\\":5,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"5-32-16\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":16,\\\"layerNum\\\":5,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"5-24-24\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":24,\\\"layerNum\\\":5,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"5-32-24\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":24,\\\"layerNum\\\":5,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"5-8-56\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":56,\\\"layerNum\\\":5,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"5-48-56\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":56,\\\"layerNum\\\":5,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"6\\\":[{\\\"id\\\":\\\"6-20-12\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":12,\\\"layerNum\\\":6,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-28-12\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":12,\\\"layerNum\\\":6,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-36-12\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":12,\\\"layerNum\\\":6,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-20-20\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":20,\\\"layerNum\\\":6,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-20-28\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":28,\\\"layerNum\\\":6,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-28-28\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":28,\\\"layerNum\\\":6,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-36-28\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":28,\\\"layerNum\\\":6,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-36-20\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":20,\\\"layerNum\\\":6,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-9-56\\\",\\\"type\\\":0,\\\"rolNum\\\":9,\\\"rowNum\\\":56,\\\"layerNum\\\":6,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"6-47-56\\\",\\\"type\\\":0,\\\"rolNum\\\":47,\\\"rowNum\\\":56,\\\"layerNum\\\":6,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"7\\\":[{\\\"id\\\":\\\"7-24-12\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":12,\\\"layerNum\\\":7,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"7-32-12\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":12,\\\"layerNum\\\":7,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"7-24-20\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":20,\\\"layerNum\\\":7,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"7-32-20\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":20,\\\"layerNum\\\":7,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"7-24-28\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":28,\\\"layerNum\\\":7,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"7-32-28\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":28,\\\"layerNum\\\":7,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"7-10-56\\\",\\\"type\\\":0,\\\"rolNum\\\":10,\\\"rowNum\\\":56,\\\"layerNum\\\":7,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"7-46-56\\\",\\\"type\\\":0,\\\"rolNum\\\":46,\\\"rowNum\\\":56,\\\"layerNum\\\":7,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"8\\\":[{\\\"id\\\":\\\"8-20-12\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":12,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-28-12\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":12,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-36-12\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":12,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-20-20\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":20,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-28-20\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":20,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-36-20\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":20,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-20-28\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":28,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-28-28\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":28,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-36-28\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":28,\\\"layerNum\\\":8,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-11-56\\\",\\\"type\\\":0,\\\"rolNum\\\":11,\\\"rowNum\\\":56,\\\"layerNum\\\":8,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"8-45-56\\\",\\\"type\\\":0,\\\"rolNum\\\":45,\\\"rowNum\\\":56,\\\"layerNum\\\":8,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"9\\\":[{\\\"id\\\":\\\"9-24-12\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":12,\\\"layerNum\\\":9,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"9-32-12\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":12,\\\"layerNum\\\":9,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"9-24-20\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":20,\\\"layerNum\\\":9,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"9-32-20\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":20,\\\"layerNum\\\":9,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"9-24-28\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":28,\\\"layerNum\\\":9,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"9-32-28\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":28,\\\"layerNum\\\":9,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"9-12-56\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":56,\\\"layerNum\\\":9,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"9-44-56\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":56,\\\"layerNum\\\":9,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"10\\\":[{\\\"id\\\":\\\"10-20-12\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":12,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-28-12\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":12,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-36-12\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":12,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-20-20\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":20,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-28-20\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":20,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-36-20\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":20,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-20-28\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":28,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-28-28\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":28,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-36-28\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":28,\\\"layerNum\\\":10,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-13-56\\\",\\\"type\\\":0,\\\"rolNum\\\":13,\\\"rowNum\\\":56,\\\"layerNum\\\":10,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"10-43-56\\\",\\\"type\\\":0,\\\"rolNum\\\":43,\\\"rowNum\\\":56,\\\"layerNum\\\":10,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"11\\\":[{\\\"id\\\":\\\"11-16-12\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":12,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-16-20\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":20,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-16-28\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":28,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-40-12\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":12,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-40-20\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":20,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-40-28\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":28,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-24-32\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":32,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-32-32\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":32,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-24-8\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":8,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-32-8\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":8,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-24-16\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":16,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-32-16\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":16,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-24-24\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":24,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-32-24\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":24,\\\"layerNum\\\":11,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-14-56\\\",\\\"type\\\":0,\\\"rolNum\\\":14,\\\"rowNum\\\":56,\\\"layerNum\\\":11,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"11-42-56\\\",\\\"type\\\":0,\\\"rolNum\\\":42,\\\"rowNum\\\":56,\\\"layerNum\\\":11,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"12\\\":[{\\\"id\\\":\\\"12-12-12\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":12,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-24-12\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":12,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-32-12\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":12,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-44-12\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":12,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-12-28\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":28,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-24-28\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":28,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-32-28\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":28,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-44-28\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":28,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-28-20\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":20,\\\"layerNum\\\":12,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-15-56\\\",\\\"type\\\":0,\\\"rolNum\\\":15,\\\"rowNum\\\":56,\\\"layerNum\\\":12,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"12-41-56\\\",\\\"type\\\":0,\\\"rolNum\\\":41,\\\"rowNum\\\":56,\\\"layerNum\\\":12,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"13\\\":[{\\\"id\\\":\\\"13-8-12\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":12,\\\"layerNum\\\":13,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-16-12\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":12,\\\"layerNum\\\":13,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-40-12\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":12,\\\"layerNum\\\":13,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-48-12\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":12,\\\"layerNum\\\":13,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-8-28\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":28,\\\"layerNum\\\":13,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-16-28\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":28,\\\"layerNum\\\":13,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-40-28\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":28,\\\"layerNum\\\":13,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-48-28\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":28,\\\"layerNum\\\":13,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-16-56\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":56,\\\"layerNum\\\":13,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"13-40-56\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":56,\\\"layerNum\\\":13,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"14\\\":[{\\\"id\\\":\\\"14-4-16\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":16,\\\"layerNum\\\":14,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-4-24\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":24,\\\"layerNum\\\":14,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-52-16\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":16,\\\"layerNum\\\":14,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-52-24\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":24,\\\"layerNum\\\":14,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-20-16\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":16,\\\"layerNum\\\":14,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-20-24\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":24,\\\"layerNum\\\":14,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-36-16\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":16,\\\"layerNum\\\":14,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-36-24\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":24,\\\"layerNum\\\":14,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-17-56\\\",\\\"type\\\":0,\\\"rolNum\\\":17,\\\"rowNum\\\":56,\\\"layerNum\\\":14,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"14-39-56\\\",\\\"type\\\":0,\\\"rolNum\\\":39,\\\"rowNum\\\":56,\\\"layerNum\\\":14,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"15\\\":[{\\\"id\\\":\\\"15-8-12\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":12,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-16-12\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":12,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-24-12\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":12,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-32-12\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":12,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-40-12\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":12,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-48-12\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":12,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-8-28\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":28,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-16-28\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":28,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-24-28\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":28,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-32-28\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":28,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-40-28\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":28,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-48-28\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":28,\\\"layerNum\\\":15,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-38-56\\\",\\\"type\\\":0,\\\"rolNum\\\":38,\\\"rowNum\\\":56,\\\"layerNum\\\":15,\\\"moldType\\\":2,\\\"blockNode\\\":null},{\\\"id\\\":\\\"15-18-56\\\",\\\"type\\\":0,\\\"rolNum\\\":18,\\\"rowNum\\\":56,\\\"layerNum\\\":15,\\\"moldType\\\":2,\\\"blockNode\\\":null}],\\\"16\\\":[{\\\"id\\\":\\\"16-4-16\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":16,\\\"layerNum\\\":16,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"16-4-24\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":24,\\\"layerNum\\\":16,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"16-52-16\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":16,\\\"layerNum\\\":16,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"16-52-24\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":24,\\\"layerNum\\\":16,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"16-20-16\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":16,\\\"layerNum\\\":16,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"16-20-24\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":24,\\\"layerNum\\\":16,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"16-36-16\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":16,\\\"layerNum\\\":16,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"16-36-24\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":24,\\\"layerNum\\\":16,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"17\\\":[{\\\"id\\\":\\\"17-8-12\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":12,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-16-12\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":12,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-24-12\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":12,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-32-12\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":12,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-40-12\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":12,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-48-12\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":12,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-8-28\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":28,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-16-28\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":28,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-24-28\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":28,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-32-28\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":28,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-40-28\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":28,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"17-48-28\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":28,\\\"layerNum\\\":17,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"18\\\":[{\\\"id\\\":\\\"18-4-16\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":16,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-4-24\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":24,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-20-16\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":16,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-20-24\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":24,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-52-16\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":16,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-52-24\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":24,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-36-16\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":16,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-36-24\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":24,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-16-8\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":8,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-24-8\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":8,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-32-8\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":8,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-40-8\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":8,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-16-32\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":32,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-24-32\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":32,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-32-32\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":32,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-40-32\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":32,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-4-8\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":8,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-52-8\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":8,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-4-32\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":32,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"18-52-32\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":32,\\\"layerNum\\\":18,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"19\\\":[{\\\"id\\\":\\\"19-16-16\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":16,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-16-24\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":24,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-40-16\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":16,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-40-24\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":24,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-20-4\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":4,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-20-36\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":36,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-28-4\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":4,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-36-4\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":4,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-28-12\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":12,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-28-28\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":28,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-28-36\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":36,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"19-36-36\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":36,\\\"layerNum\\\":19,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"20\\\":[{\\\"id\\\":\\\"20-20-12\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":12,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-20-20\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":20,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-20-28\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":28,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-36-12\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":12,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-36-20\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":20,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-36-28\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":28,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-16-0\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":0,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-24-0\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":0,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-32-0\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":0,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-40-0\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":0,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-16-40\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":40,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-24-40\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":40,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-40-40\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":40,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-32-40\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":40,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-28-8\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":8,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"20-28-32\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":32,\\\"layerNum\\\":20,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"21\\\":[{\\\"id\\\":\\\"21-16-8\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":8,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-16-16\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":16,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-16-24\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":24,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-16-32\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":32,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-40-8\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":8,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-40-16\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":16,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-40-24\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":24,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-40-32\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":32,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-24-20\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":20,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"21-32-20\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":20,\\\"layerNum\\\":21,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"22\\\":[{\\\"id\\\":\\\"22-12-8\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":8,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-20-8\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":8,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-36-8\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":8,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-44-8\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":8,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-12-32\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":32,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-20-32\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":32,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-36-32\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":32,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-44-32\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":32,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-16-20\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":20,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-40-20\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":20,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"22-28-20\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":20,\\\"layerNum\\\":22,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"23\\\":[{\\\"id\\\":\\\"23-16-4\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":4,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-24-4\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":4,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-32-4\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":4,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-40-4\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":4,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-16-12\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":12,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-16-28\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":28,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-16-36\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":36,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-24-12\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":12,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-32-12\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":12,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-40-12\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":12,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-24-28\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":28,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-32-28\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":28,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-40-28\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":28,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-24-36\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":36,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-32-36\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":36,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"23-40-36\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":36,\\\"layerNum\\\":23,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"24\\\":[{\\\"id\\\":\\\"24-12-8\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":8,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-12-16\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":16,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-12-24\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":24,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-12-32\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":32,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-44-8\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":8,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-44-16\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":16,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-44-24\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":24,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-44-32\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":32,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-28-12\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":12,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-28-28\\\",\\\"type\\\":0,\\\"rolNum\\\":28,\\\"rowNum\\\":28,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-16-40\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":40,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-24-40\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":40,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-32-40\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":40,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"24-40-40\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":40,\\\"layerNum\\\":24,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"25\\\":[{\\\"id\\\":\\\"25-16-8\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":8,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-40-8\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":8,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-16-16\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":16,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-16-24\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":24,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-16-32\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":32,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-40-16\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":16,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-40-24\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":24,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-40-32\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":32,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-8-12\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":12,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-8-20\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":20,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-8-28\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":28,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-48-12\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":12,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-48-20\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":20,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-48-28\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":28,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-12-44\\\",\\\"type\\\":0,\\\"rolNum\\\":12,\\\"rowNum\\\":44,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"25-44-44\\\",\\\"type\\\":0,\\\"rolNum\\\":44,\\\"rowNum\\\":44,\\\"layerNum\\\":25,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"26\\\":[{\\\"id\\\":\\\"26-20-12\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":12,\\\"layerNum\\\":26,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"26-20-20\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":20,\\\"layerNum\\\":26,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"26-20-28\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":28,\\\"layerNum\\\":26,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"26-36-12\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":12,\\\"layerNum\\\":26,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"26-36-20\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":20,\\\"layerNum\\\":26,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"26-36-28\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":28,\\\"layerNum\\\":26,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"26-8-44\\\",\\\"type\\\":0,\\\"rolNum\\\":8,\\\"rowNum\\\":44,\\\"layerNum\\\":26,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"26-48-44\\\",\\\"type\\\":0,\\\"rolNum\\\":48,\\\"rowNum\\\":44,\\\"layerNum\\\":26,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"27\\\":[{\\\"id\\\":\\\"27-24-32\\\",\\\"type\\\":0,\\\"rolNum\\\":24,\\\"rowNum\\\":32,\\\"layerNum\\\":27,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"27-32-32\\\",\\\"type\\\":0,\\\"rolNum\\\":32,\\\"rowNum\\\":32,\\\"layerNum\\\":27,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"27-4-44\\\",\\\"type\\\":0,\\\"rolNum\\\":4,\\\"rowNum\\\":44,\\\"layerNum\\\":27,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"27-52-44\\\",\\\"type\\\":0,\\\"rolNum\\\":52,\\\"rowNum\\\":44,\\\"layerNum\\\":27,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"28\\\":[{\\\"id\\\":\\\"28-20-28\\\",\\\"type\\\":0,\\\"rolNum\\\":20,\\\"rowNum\\\":28,\\\"layerNum\\\":28,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"28-36-28\\\",\\\"type\\\":0,\\\"rolNum\\\":36,\\\"rowNum\\\":28,\\\"layerNum\\\":28,\\\"moldType\\\":1,\\\"blockNode\\\":null}],\\\"29\\\":[{\\\"id\\\":\\\"29-16-24\\\",\\\"type\\\":0,\\\"rolNum\\\":16,\\\"rowNum\\\":24,\\\"layerNum\\\":29,\\\"moldType\\\":1,\\\"blockNode\\\":null},{\\\"id\\\":\\\"29-40-24\\\",\\\"type\\\":0,\\\"rolNum\\\":40,\\\"rowNum\\\":24,\\\"layerNum\\\":29,\\\"moldType\\\":1,\\\"blockNode\\\":null}]}}\"}}"
        }
        return ""
    }

    companion object {
        private var clipData: String = ""
    }
}

data class PutDataRequest(
    val id: Int? = null,
    val value: String? = null
)